/* SCCS @(#)ioparametres.layout.c	1.1  12/2/92 */
/************************************************************************/
/************************************************************************/
/*                                                                      */
/*                        ioparametres.layout.c                         */
/*                                                                      */
/************************************************************************/
/************************************************************************/
/*                                                                      */
/* FILENAME     :   ioparametres.layout.c                               */
/*                                                                      */
/* DESCRIPTION  :   IO load parameters                                  */
/*                                                                      */
/* AUTHORS      :   Marianne Logean                                     */
/*                                                                      */
/* VERSION      :   1.0                                                 */
/*                                                                      */
/* HISTORY      :   1.12.92                                             */
/*                  MAL         Created    version: 1.0                 */
/*                                                                      */
/* Copyright  1992 by CUI/UIN/HCUG, All rights reserved.                */
/*                                                                      */
/************************************************************************/
/************************************************************************/

#include "widgetstructure.h"
#include "ioparametres.layout.h"

#define MAX_ARGS 100

extern XmFontList gFontlist, gSmall_fontlist;

/********************************************************
/   Creation Function for IO_parametres_widget 
/*******************************************************/

xs_struc_widgetparamIO *build_IO_parametres_widget (IOparametres)
	Widget IOparametres;
{
	Widget IO_parametres_widget;
	xs_struc_widgetparamIO *IO_parametres_widget5;
	Widget header_length;
	Widget No_rows_image;
	Widget No_bytes_row;
	Widget No_columns_image;
	Widget No_bytes_to_skip_pixel;
	Widget header_length_text;
	Widget No_rows_image_text;
	Widget No_columns_image_text;
	Widget No_bytes_to_skip_pixel_text;
	Widget No_bytes_row_text;
	Widget IO_parametres_Label_0;
	Arg args[MAX_ARGS];
	int n;

	/* Creating IO_parametres_widget Widget */ 

	n = 0;
	XtSetArg(args[n],XmNheight,256); n++;
	XtSetArg(args[n],XmNresizePolicy,XmRESIZE_NONE); n++;
	XtSetArg(args[n],XmNwidth,185); n++;
	XtSetArg(args[n],XmNx,27); n++;
	XtSetArg(args[n],XmNy,19); n++;

	IO_parametres_widget = XmCreateForm(IOparametres,"IO_parametres_widget",args,n);

	IO_parametres_widget5 = 
		(xs_struc_widgetparamIO *) malloc (sizeof (xs_struc_widgetparamIO));

	IO_parametres_widget5->parent = IO_parametres_widget;

	/* Creating header_length Widget */ 

	n = 0;
	XtSetArg(args[n],XmNalignment,XmALIGNMENT_BEGINNING); n++;
	XtSetArg(args[n],XmNfontList, gFontlist); n++;
	XtSetArg(args[n],XmNlabelString,
		XmStringLtoRCreate(paneltabs[256],
			XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNrightPosition,40); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,25); n++;

	header_length = XmCreateLabel(IO_parametres_widget,"header_length",args,n);
	XtManageChild(header_length);

	/* Creating No_rows_image Widget */ 

	n = 0;
	XtSetArg(args[n],XmNalignment,XmALIGNMENT_BEGINNING); n++;
	XtSetArg(args[n],XmNfontList, gFontlist); n++;
	XtSetArg(args[n],XmNlabelString,
		XmStringLtoRCreate(paneltabs[257],
			XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNrightPosition,40); n++;
	XtSetArg(args[n],XmNrightWidget,NULL); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,40); n++;

	No_rows_image = XmCreateLabel(IO_parametres_widget,"No_rows_image",args,n);
	XtManageChild(No_rows_image);

	/* Creating No_bytes_row Widget */ 

	n = 0;
	XtSetArg(args[n],XmNalignment,XmALIGNMENT_BEGINNING); n++;
	XtSetArg(args[n],XmNfontList, gFontlist); n++;
	XtSetArg(args[n],XmNlabelString,
		XmStringLtoRCreate(paneltabs[258],
			XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNrightPosition,40); n++;
	XtSetArg(args[n],XmNrightWidget,NULL); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,55); n++;

	No_bytes_row = XmCreateLabel(IO_parametres_widget,"No_bytes_row",args,n);
	XtManageChild(No_bytes_row);

	/* Creating No_columns_image Widget */ 

	n = 0;
	XtSetArg(args[n],XmNalignment,XmALIGNMENT_BEGINNING); n++;
	XtSetArg(args[n],XmNfontList, gFontlist); n++;
	XtSetArg(args[n],XmNlabelString,
		XmStringLtoRCreate(paneltabs[259],
			XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNrightPosition,40); n++;
	XtSetArg(args[n],XmNrightWidget,NULL); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,70); n++;

	No_columns_image = XmCreateLabel(IO_parametres_widget,"No_columns_image",args,n);
	XtManageChild(No_columns_image);

	/* Creating No_bytes_to_skip_pixel Widget */ 

	n = 0;
	XtSetArg(args[n],XmNalignment,XmALIGNMENT_BEGINNING); n++;
	XtSetArg(args[n],XmNfontList, gFontlist); n++;
	XtSetArg(args[n],XmNlabelString,
		XmStringLtoRCreate(paneltabs[260],
			XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNrightPosition,40); n++;
	XtSetArg(args[n],XmNrightWidget,NULL); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,85); n++;

	No_bytes_to_skip_pixel = XmCreateLabel(IO_parametres_widget,"No_bytes_to_skip_pixel",args,n);
	XtManageChild(No_bytes_to_skip_pixel);

	/* Creating header_length_text Widget */ 

	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,header_length); n++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNrightPosition,95); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,25); n++;
	XtSetArg(args[n],XmNfontList, gSmall_fontlist); n++;

	header_length_text = XmCreateText(IO_parametres_widget,"header_length_text",args,n);
	XtManageChild(header_length_text);

        IO_parametres_widget5->header_length = header_length_text;

	/* Creating No_rows_image_text Widget */ 

	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,No_rows_image); n++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNrightPosition,95); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,40); n++;
	XtSetArg(args[n],XmNfontList, gSmall_fontlist); n++;

	No_rows_image_text = XmCreateText(IO_parametres_widget,
					  "No_rows_image_text",args,n);
	XtManageChild(No_rows_image_text);

        IO_parametres_widget5->No_rows_image = No_rows_image_text;

	/* Creating No_columns_image_text Widget */ 

	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,No_columns_image); n++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNrightPosition,95); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,70); n++;
	XtSetArg(args[n],XmNfontList, gSmall_fontlist); n++;

	No_columns_image_text = XmCreateText(IO_parametres_widget,
				       "No_columns_image_text",args,n);
	XtManageChild(No_columns_image_text);

        IO_parametres_widget5->No_columns_image = No_columns_image_text;

	/* Creating No_bytes_to_skip_pixel_text Widget */ 

	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,No_bytes_to_skip_pixel); n++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNrightPosition,95); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,85); n++;
	XtSetArg(args[n],XmNfontList, gSmall_fontlist); n++;

	No_bytes_to_skip_pixel_text = XmCreateText(IO_parametres_widget,
				 "No_bytes_to_skip_pixel_text",args,n);
	XtManageChild(No_bytes_to_skip_pixel_text);

        IO_parametres_widget5->No_bytes_to_skip_pixel = No_bytes_to_skip_pixel_text;

	/* Creating No_bytes_row_text Widget */ 

	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,No_bytes_row); n++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNrightPosition,95); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,55); n++;
	XtSetArg(args[n],XmNfontList, gSmall_fontlist); n++;

	No_bytes_row_text = XmCreateText(IO_parametres_widget,
					 "No_bytes_row_text",args,n);
	XtManageChild(No_bytes_row_text);

        IO_parametres_widget5->No_bytes_row = No_bytes_row_text;

	/* Creating IO_parametres_Label_0 Widget */ 

	n = 0;
	XtSetArg(args[n],XmNalignment,XmALIGNMENT_BEGINNING); n++;
	XtSetArg(args[n],XmNfontList, gFontlist); n++;
	XtSetArg(args[n],XmNlabelString,
		XmStringLtoRCreate(paneltabs[266],
			XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION); n++;
	XtSetArg(args[n],XmNtopPosition,5); n++;

	IO_parametres_Label_0 = XmCreateLabel(IO_parametres_widget,"IO_parametres_Label_0",args,n);
	XtManageChild(IO_parametres_Label_0);

	return(IO_parametres_widget5);
}
